let bigInt = require('big-integer');

module.exports = {
    writeBigUInt64LE,
}

function verifyBigUInt64(n) {
    if (typeof(n) === 'number') {
        if (n < 0) {
            throw "not a valid positive integer";
        }
        if (!Number.isSafeInteger(n)) {
            throw "not a safe integer";
        }
		return BigInt(n);
    } else if (typeof(n) === 'bigint') {
        return n
    } else {
        throw "not a valid bigint or convertible value";
    }
}

function writeBigUInt64LE(n) {
    n = verifyBigUInt64(n);
    let poly = bigInt(n);

    let b = Buffer.from(poly.toArray(256).value.reverse());
    if (b.length > 8) {
        throw "not a valid bigint or convertible value";
    }

    let diff = 8 - b.length;
    let pad = Buffer.alloc(diff);
    return Buffer.concat([b, pad]);
}

